//+------------------------------------------------------------------+
//|                                            MacdACSignals.mq4.mq4 |
//|                                              Tonkonog G.S., 2009 |
//|                                    hurricane79@yandex.ru         |
//+------------------------------------------------------------------+
#property copyright "Tonkonog G.S., 2009"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Yellow
//---- input parameters
extern int       barsToProcess=500;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,236);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,238);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(1,0.0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);  
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted(),
       limit;
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
   if(limit>barsToProcess)
      limit=barsToProcess;
//----
   for(int i=0;i<limit;i++)
   {
    double MacdCurrent, MacdPrevious, SignalCurrent, SignalPrevious,
           AC1,AC2,AC3,AC4,AC5;
           
    MacdCurrent=iMACD(NULL,0,5,34,5,PRICE_CLOSE,MODE_MAIN,i);
    MacdPrevious=iMACD(NULL,0,5,34,5,PRICE_CLOSE,MODE_MAIN,i+1);
    SignalCurrent=iMACD(NULL,0,5,34,5,PRICE_CLOSE,MODE_SIGNAL,i);
    SignalPrevious=iMACD(NULL,0,5,34,5,PRICE_CLOSE,MODE_SIGNAL,i+1);
    AC1=iAC(NULL,0,i+1);
    AC2=iAC(NULL,0,i+2);
    AC3=iAC(NULL,0,i+3);
    AC4=iAC(NULL,0,i+4);
    AC5=iAC(NULL,0,i+5);
    
//    if(MacdCurrent>0 && MacdCurrent>SignalCurrent
//       && MacdPrevious<SignalPrevious)
//       ExtMapBuffer1[i]=High[i]+15*Point;
    if((MacdCurrent>0 && MacdPrevious<0) &&
      (((AC4>0 && AC3>0 && AC2>0 && AC1>0) && (AC4>AC3 && AC2>AC3 && AC1>AC2)) ||
      ((AC4<0 && AC3<0 && AC2<0 && AC1>0) && (AC4>AC3 && AC2>AC3 && AC1>AC2)) ||
      ((AC5<0 && AC4<0 && AC3<0 && AC2<0 && AC1<0) &&
      (AC5>AC4 && AC4<AC3 && AC3<AC2 && AC2<AC1))))
       ExtMapBuffer1[i]=High[i]+15*Point;
        
//    if(MacdCurrent<0 && MacdCurrent<SignalCurrent
//       && MacdPrevious>SignalPrevious)
//       ExtMapBuffer2[i]=Low[i]-15*Point;
//    if(MacdCurrent<0 && MacdPrevious>0)
//       ExtMapBuffer2[i]=Low[i]-15*Point;
       
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+